"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _bodyScrollLock = require("body-scroll-lock");

var _reactTransitionGroup = require("react-transition-group");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _scrollbarSize = _interopRequireDefault(require("../utils/scrollbarSize"));

var _toggleClass = _interopRequireDefault(require("../toggle-class"));

var _ModalDialog = _interopRequireDefault(require("./dom/ModalDialog"));

var _ModalHeader = _interopRequireDefault(require("./dom/ModalHeader"));

var _ModalBody = _interopRequireDefault(require("./dom/ModalBody"));

var _Backdrop = _interopRequireDefault(require("./dom/Backdrop"));

// This keeps track of how many modals that are open so that the
// container class and container padding for the scrollbar is correctly set.
var numberOfModalsOpen = 0;
var keyCodes = {
  ESCAPE: 27,
  ENTER: 13
};

var shouldBindKeyboard = function shouldBindKeyboard(_ref) {
  var isOpen = _ref.isOpen,
      keyboard = _ref.keyboard;
  return keyboard === null ? isOpen : keyboard;
};

var Modal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Modal, _Component);

  function Modal(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Modal);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Modal).call(this, props));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCancel", function (e, extra) {
      // Don't do anything while animating
      var animating = _this.state.animating;

      if (animating) {
        return;
      }

      var _this$props = _this.props,
          isOpen = _this$props.isOpen,
          isStatic = _this$props.isStatic,
          onCancel = _this$props.onCancel;

      if (isOpen && !isStatic && onCancel) {
        onCancel(e, extra);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearAnimating", function () {
      _this.setState({
        animating: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeys", function (e) {
      // Handle escape press
      if (e.which === keyCodes.ESCAPE) {
        _this.onCancel(e, true);
      } else if (e.which === keyCodes.ENTER) {
        // Don't do anything while animating
        var animating = _this.state.animating;

        if (!animating) {
          var onConfirm = _this.props.onConfirm;

          if (onConfirm) {
            e.preventDefault();
            onConfirm();
          }
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderChild", function (child) {
      if (!child) {
        return child;
      }

      var onCancel = _this.props.onCancel;

      var _ref2 = child.props || {},
          addClose = _ref2.addClose,
          headerOnCancel = _ref2.headerOnCancel;

      if (child.type === _ModalHeader["default"] && addClose && !headerOnCancel) {
        return _react["default"].cloneElement(child, (0, _objectSpread2["default"])({}, child.props, {
          onCancel: onCancel
        }));
      }

      return child;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderTransition", function (element) {
      var TransitionClass = _this.props.TransitionClass;
      return _react["default"].createElement(TransitionClass, (0, _extends2["default"])({
        key: element.key
      }, _this.getAnimatorProps()), _react["default"].cloneElement(element));
    });
    _this.state = {
      animating: false
    };
    _this.node = _react["default"].createRef(); // validate children props and warn if something is wrong

    _react["default"].Children.forEach(props.children, function (child) {
      if (child && child.type === _ModalHeader["default"]) {
        if (child.props.addClose && !child.props.onCancel) {
          // eslint-disable-next-line no-console
          console.warn("".concat(_ModalHeader["default"].displayName, ": addClose is defined but onCancel is missing!"));
        }
      }
    });

    return _this;
  }

  (0, _createClass2["default"])(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var isOpen = this.props.isOpen;
      this.onToggle(isOpen, this.getToggleProps());

      if (typeof document !== 'undefined') {
        if (shouldBindKeyboard(this.props)) {
          this.bindKeyboard();
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var isOpen = this.props.isOpen;

      if (prevProps.isOpen !== isOpen) {
        this.setState({
          animating: true
        });
      }

      var animating = this.state.animating;

      if (!prevState.animating && animating) {
        this.onToggle(isOpen, this.getToggleProps());
      }

      var wasBound = shouldBindKeyboard(prevProps);
      var shouldBind = shouldBindKeyboard(this.props);

      if (wasBound !== shouldBind) {
        if (shouldBind) {
          this.bindKeyboard();
        } else {
          this.unbindKeyboard();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var isOpen = this.props.isOpen;

      if (isOpen) {
        this.onToggle(false, this.getToggleProps());
      }

      if (typeof document !== 'undefined') {
        this.unbindKeyboard();
      }
    }
  }, {
    key: "onToggle",
    value: function onToggle(state, props) {
      var onToggle = this.props.onToggle;

      if (onToggle) {
        onToggle(state, props);
      } // Add body class and padding to scrollbar.


      if (typeof document !== 'undefined') {
        var _document = document,
            body = _document.body; // Increment modal count when opening.

        if (state) {
          numberOfModalsOpen += 1;
        } // Add toggle body class and update body padding if there is only one modal open.


        if (numberOfModalsOpen === 1) {
          // Toggle open class.
          (0, _toggleClass["default"])(body, 'tg-modal-open', state);
          var bodyScrollLock = this.props.bodyScrollLock;

          if (state) {
            if (bodyScrollLock && this.node.current) {
              (0, _bodyScrollLock.disableBodyScroll)(this.node.current, {
                reserveScrollBarGap: true
              });
            }
          } else if (bodyScrollLock && this.node.current) {
            (0, _bodyScrollLock.clearAllBodyScrollLocks)();
          }
        } // Decrement modal count when closing.


        if (!state) {
          numberOfModalsOpen = Math.max(numberOfModalsOpen - 1, 0);
        }
      }
    }
  }, {
    key: "getToggleProps",
    value: function getToggleProps(isOpen) {
      return {
        scrollbarSize: typeof document !== 'undefined' ? (0, _scrollbarSize["default"])() : null,
        className: isOpen ? 'tg-modal-open' : ''
      };
    }
  }, {
    key: "getAnimatorProps",
    value: function getAnimatorProps() {
      var _this$props2 = this.props,
          transitionName = _this$props2.transitionName,
          transitionDuration = _this$props2.transitionDuration;
      var animating = this.state.animating;
      return {
        classNames: transitionName,
        timeout: transitionDuration,
        onEntered: this.clearAnimating,
        onExited: this.clearAnimating,
        unmountOnExit: true,
        "in": animating
      };
    }
  }, {
    key: "getAnimatorGroupProps",
    value: function getAnimatorGroupProps() {
      var wrapperClassName = this.props.wrapperClassName;
      var animating = this.state.animating;
      return {
        component: 'div',
        className: "tg-modal-wrapper ".concat(wrapperClassName, " ").concat(animating ? 'tg-modal-animating' : '').trim()
      };
    }
  }, {
    key: "bindKeyboard",
    value: function bindKeyboard() {
      // Ensure we don't bind twice
      this.unbindKeyboard();

      if (typeof document !== 'undefined') {
        this._keyHandler = this.handleKeys;
        document.addEventListener('keyup', this._keyHandler, false);
      }
    }
  }, {
    key: "unbindKeyboard",
    value: function unbindKeyboard() {
      if (typeof document !== 'undefined') {
        if (this._keyHandler) {
          document.removeEventListener('keyup', this._keyHandler, false);
          this._keyHandler = null;
        }
      }
    }
  }, {
    key: "renderModalBody",
    value: function renderModalBody() {
      var _this$props3 = this.props,
          autoWrap = _this$props3.autoWrap,
          children = _this$props3.children;

      var nodes = _react["default"].Children.map(children, this.renderChild);

      if (autoWrap) {
        return _react["default"].createElement(_ModalBody["default"], null, nodes);
      }

      return nodes;
    }
  }, {
    key: "renderModalHeader",
    value: function renderModalHeader() {
      var _this$props4 = this.props,
          title = _this$props4.title,
          isStatic = _this$props4.isStatic;

      if (!title) {
        // No title: Return nothing
        return null;
      } else if (typeof title === 'string') {
        // Title is a string, return a ModalHeader
        return _react["default"].createElement(_ModalHeader["default"], {
          addClose: !isStatic,
          onCancel: this.onCancel
        }, title);
      } else {
        // Fall back to rendering title directly (events should be handled by parent)
        return title;
      }
    }
  }, {
    key: "renderModal",
    value: function renderModal() {
      var _this$props5 = this.props,
          isOpen = _this$props5.isOpen,
          isBasic = _this$props5.isBasic,
          isStatic = _this$props5.isStatic,
          dialogClassName = _this$props5.dialogClassName,
          className = _this$props5.className;

      if (!isOpen) {
        return [];
      }

      return [this.renderTransition(_react["default"].createElement(_Backdrop["default"], {
        isStatic: isStatic,
        onCancel: this.onCancel,
        key: "backdrop"
      })), this.renderTransition(_react["default"].createElement(_ModalDialog["default"], {
        key: "dialog",
        isBasic: isBasic,
        onCancel: this.onCancel,
        className: dialogClassName,
        modalClassName: className,
        nodeRef: this.node
      }, this.renderModalHeader(), this.renderModalBody()))];
    }
  }, {
    key: "render",
    value: function render() {
      var TransitionGroupClass = this.props.TransitionGroupClass;
      return _react["default"].createElement(TransitionGroupClass, this.getAnimatorGroupProps(), this.renderModal());
    }
  }]);
  return Modal;
}(_react.Component);

(0, _defineProperty2["default"])(Modal, "displayName", 'Modal');
(0, _defineProperty2["default"])(Modal, "propTypes", {
  isOpen: _propTypes["default"].bool.isRequired,
  onCancel: _propTypes["default"].func.isRequired,
  onConfirm: _propTypes["default"].func,
  children: _propTypes["default"].node,
  isStatic: _propTypes["default"].bool,
  isBasic: _propTypes["default"].bool,
  autoWrap: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  dialogClassName: _propTypes["default"].string,
  wrapperClassName: _propTypes["default"].string,
  transitionName: _propTypes["default"].string,
  transitionDuration: _propTypes["default"].number,
  title: _propTypes["default"].node,
  TransitionClass: _propTypes["default"].func,
  TransitionGroupClass: _propTypes["default"].func,
  style: _propTypes["default"].object,
  // eslint-disable-line react/forbid-prop-types
  // Enable/disable keyboard events.
  // When null, the default, it will behave as having same value as isOpen
  keyboard: _propTypes["default"].bool,
  // Enable/disable body scroll locking
  bodyScrollLock: _propTypes["default"].bool,
  // This is internally used
  onToggle: _propTypes["default"].func
});
(0, _defineProperty2["default"])(Modal, "defaultProps", {
  autoWrap: false,
  children: null,
  className: '',
  dialogClassName: 'tg-modal-dialog',
  wrapperClassName: '',
  isStatic: false,
  isBasic: false,
  bodyScrollLock: true,
  transitionName: 'tg-modal-fade',
  transitionDuration: 300,
  keyboard: null,
  onToggle: null,
  onConfirm: null,
  title: null,
  style: null,
  TransitionClass: _reactTransitionGroup.CSSTransition,
  TransitionGroupClass: _reactTransitionGroup.TransitionGroup
});
var _default = Modal;
exports["default"] = _default;